﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace ServidorTeste
{
    class Program
    {
        static void Main(string[] args)
        {
            // Um Socket Listener atua como um servidor e ouve as
            // mensagens de entrada na porta e no protocolo especificados.
            IniciaServidor();
            return;
        }
        public static void IniciaServidor()
        {
            // Pega o endereço IP do Host que é usado para conexão
            // No exemplo, pegamos um endereço IP que é  : 127.0.0.1  
            // Se o host possuir multiplos endereços pegamos uma lista
            IPHostEntry host = Dns.GetHostEntry("localhost");
            IPAddress ipAddress = host.AddressList[0];
            IPEndPoint localEndPoint = new IPEndPoint(ipAddress, 11000);

            try
            {
                // Cria um Socket que vai usar o protocolo TCP
                Socket listener = new Socket(ipAddress.AddressFamily, SocketType.Stream, ProtocolType.Tcp);
                // Um Socket precisa estar associado com um endpoint usando o método Bind
                listener.Bind(localEndPoint);
                // Especifica quantos requests um socket pode escutar antes do servidor ficar ocupado
                // Vamos definir apenas 10 requests por vez
                listener.Listen(10);

                Console.WriteLine("Aguardando a conexão...");
                Socket handler = listener.Accept();

                // Dados chegando do cliente
                string data = null;
                byte[] bytes = null;

                while (true)
                {
                    bytes = new byte[1024];
                    int bytesRec = handler.Receive(bytes);
                    data += Encoding.ASCII.GetString(bytes, 0, bytesRec);
                    if (data.IndexOf("<EOF>") > -1)
                    {
                        break;
                    }
                }

                Console.WriteLine("Texto recebido : {0}", data);

                byte[] msg = Encoding.ASCII.GetBytes(data);
                handler.Send(msg);
                handler.Shutdown(SocketShutdown.Both);
                handler.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
            }

            Console.WriteLine("\n Tecle algo para continuar...");
            Console.ReadKey();
        }
    }
}